package io.fabric8.kubernetes.api.model.rbac;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import io.fabric8.kubernetes.api.builder.Nested;
import java.util.ArrayList;
import io.fabric8.kubernetes.api.model.validators.CheckObjectMeta;
import java.lang.String;
import javax.validation.constraints.NotNull;
import io.fabric8.kubernetes.api.builder.Predicate;
import io.fabric8.kubernetes.api.model.ObjectMetaFluent;
import java.lang.Deprecated;
import java.util.List;
import java.lang.Boolean;
import io.fabric8.kubernetes.api.model.ObjectMeta;
import io.fabric8.kubernetes.api.builder.Fluent;
import io.fabric8.kubernetes.api.model.ObjectMetaBuilder;
import javax.validation.Valid;
import java.util.Collection;
import java.lang.Object;
import java.util.Map;

public interface KubernetesClusterRoleFluent<A extends KubernetesClusterRoleFluent<A>> extends Fluent<A>{


    
/**
 * This method has been deprecated, please use method buildAggregationRule instead.
 * @return The buildable object.
 */
@Deprecated public KubernetesAggregationRule getAggregationRule();
    public KubernetesAggregationRule buildAggregationRule();
    public A withAggregationRule(KubernetesAggregationRule aggregationRule);
    public Boolean hasAggregationRule();
    public KubernetesClusterRoleFluent.AggregationRuleNested<A> withNewAggregationRule();
    public KubernetesClusterRoleFluent.AggregationRuleNested<A> withNewAggregationRuleLike(KubernetesAggregationRule item);
    public KubernetesClusterRoleFluent.AggregationRuleNested<A> editAggregationRule();
    public KubernetesClusterRoleFluent.AggregationRuleNested<A> editOrNewAggregationRule();
    public KubernetesClusterRoleFluent.AggregationRuleNested<A> editOrNewAggregationRuleLike(KubernetesAggregationRule item);
    public String getApiVersion();
    public A withApiVersion(String apiVersion);
    public Boolean hasApiVersion();
    public String getKind();
    public A withKind(String kind);
    public Boolean hasKind();
    
/**
 * This method has been deprecated, please use method buildMetadata instead.
 * @return The buildable object.
 */
@Deprecated public ObjectMeta getMetadata();
    public ObjectMeta buildMetadata();
    public A withMetadata(ObjectMeta metadata);
    public Boolean hasMetadata();
    public KubernetesClusterRoleFluent.MetadataNested<A> withNewMetadata();
    public KubernetesClusterRoleFluent.MetadataNested<A> withNewMetadataLike(ObjectMeta item);
    public KubernetesClusterRoleFluent.MetadataNested<A> editMetadata();
    public KubernetesClusterRoleFluent.MetadataNested<A> editOrNewMetadata();
    public KubernetesClusterRoleFluent.MetadataNested<A> editOrNewMetadataLike(ObjectMeta item);
    public A addToRules(int index,KubernetesPolicyRule item);
    public A setToRules(int index,KubernetesPolicyRule item);
    public A addToRules(KubernetesPolicyRule... items);
    public A addAllToRules(Collection<KubernetesPolicyRule> items);
    public A removeFromRules(KubernetesPolicyRule... items);
    public A removeAllFromRules(Collection<KubernetesPolicyRule> items);
    
/**
 * This method has been deprecated, please use method buildRules instead.
 * @return The buildable object.
 */
@Deprecated public List<KubernetesPolicyRule> getRules();
    public List<KubernetesPolicyRule> buildRules();
    public KubernetesPolicyRule buildRule(int index);
    public KubernetesPolicyRule buildFirstRule();
    public KubernetesPolicyRule buildLastRule();
    public KubernetesPolicyRule buildMatchingRule(io.fabric8.kubernetes.api.builder.Predicate<KubernetesPolicyRuleBuilder> predicate);
    public A withRules(List<KubernetesPolicyRule> rules);
    public A withRules(KubernetesPolicyRule... rules);
    public Boolean hasRules();
    public KubernetesClusterRoleFluent.RulesNested<A> addNewRule();
    public KubernetesClusterRoleFluent.RulesNested<A> addNewRuleLike(KubernetesPolicyRule item);
    public KubernetesClusterRoleFluent.RulesNested<A> setNewRuleLike(int index,KubernetesPolicyRule item);
    public KubernetesClusterRoleFluent.RulesNested<A> editRule(int index);
    public KubernetesClusterRoleFluent.RulesNested<A> editFirstRule();
    public KubernetesClusterRoleFluent.RulesNested<A> editLastRule();
    public KubernetesClusterRoleFluent.RulesNested<A> editMatchingRule(io.fabric8.kubernetes.api.builder.Predicate<KubernetesPolicyRuleBuilder> predicate);

    public interface AggregationRuleNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,KubernetesAggregationRuleFluent<KubernetesClusterRoleFluent.AggregationRuleNested<N>>{

        
    public N and();    public N endAggregationRule();
}
    public interface MetadataNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,ObjectMetaFluent<KubernetesClusterRoleFluent.MetadataNested<N>>{

        
    public N and();    public N endMetadata();
}
    public interface RulesNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,KubernetesPolicyRuleFluent<KubernetesClusterRoleFluent.RulesNested<N>>{

        
    public N and();    public N endRule();
}


}
